/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */

package org.dive4elements.river.importer;

import java.util.List;

import org.apache.log4j.Logger;
import org.dive4elements.river.model.AnnotationType;
import org.hibernate.Query;
import org.hibernate.Session;

public class ImportAnnotationType
implements   Comparable<ImportAnnotationType>
{
    private static final Logger log = Logger.getLogger(ImportAnnotationType.class);
    protected String         name;
    protected AnnotationType peer;

    public ImportAnnotationType() {
    }

    public ImportAnnotationType(final String name) {
        this.name = name;
    }

    @Override
    public int compareTo(final ImportAnnotationType other) {
        return this.name.compareTo(other.name);
    }

    public String getName() {
        return this.name;
    }

    public void setName(final String name) {
        this.name = name;
    }


    public AnnotationType getPeer() {
        if (this.peer != null)
            return this.peer;
        final Session session = ImporterSession.getInstance().getDatabaseSession();
        final Query query = session.createQuery("FROM AnnotationType WHERE lower(name)=:name");
        query.setParameter("name", this.name.trim().toLowerCase());
        final List<AnnotationType> types = query.list();
        if (types.isEmpty()) {
            this.peer = new AnnotationType(this.name);
            session.save(this.peer);
            log.info(String.format("Create new database instance: %d, '%s'", this.peer.getId(), this.name));
        }
        else {
            this.peer = types.get(0);
        }
        return this.peer;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
